
(in-package "ELE-TESTS")
;;(unuse-package "ELE")
;;(use-package "SLEEPYCAT")

(defvar env)
(defvar db)

(defun prepare-sleepycat()
  (setq env (sleepycat::db-env-create))
  (sleepycat::db-env-open env *sleepycatdb-path* :create t :init-txn t :init-lock t 
	       :init-mpool t :init-log t :thread t
	       :recover-fatal t)
  
  (setq db (sleepycat::db-create env))
  (sleepycat::db-open db :file "testsleepycat" :database "bar" :type SLEEPYCAT::DB-BTREE
	   :auto-commit t :create t :thread t))

(deftest prepares-sleepycat
    (finishes (prepare-sleepycat)) t)

#|
(deftest put-alot
    (finishes
     (loop for key in keys
	   do
	   (sleepycat::db-put db key key :auto-commit t)))
  t)
  
(defun get-alot ()
  (loop for key in keys
	always (string= key (sleepycat::db-get db key))))

(deftest put-right (get-alot) t)

(deftest put-alot-b 
    (finishes
     (with-transaction (:environment env)
       (loop for key in keys
	     do
	     (sleepycat::db-put db key key))))
  t)

(deftest put-right-b (get-alot) t)
|#

(defun test-sequence1 ()
  (let ((seq (sleepycat::db-sequence-create db)))
    (sleepycat::db-sequence-set-cachesize seq 1000)
    (sleepycat::db-sequence-set-flags seq :seq-inc t :seq-wrap t)
    (sleepycat::db-sequence-set-range seq 0 most-positive-fixnum)
    (sleepycat::db-sequence-initial-value seq (- most-positive-fixnum 99))
    (sleepycat::db-sequence-open seq "testseq1"
		      :auto-commit t :create t :thread t)
    (loop for i = (sleepycat::db-sequence-get-fixnum seq 1 :auto-commit t :txn-nosync t)
	  for j from (- most-positive-fixnum 99) to most-positive-fixnum
	  while (> i 0)
	  do
	  (assert (= i j))
	  finally (sleepycat::db-sequence-remove seq :auto-commit t))))

(deftest test-seq1
    (finishes (test-sequence1))
  t)

(defun test-sequence2 ()
  (let ((seq (sleepycat::db-sequence-create db)))
    (sleepycat::db-sequence-set-cachesize seq 1000)
    (sleepycat::db-sequence-set-flags seq :seq-dec t :seq-wrap t)
    (sleepycat::db-sequence-set-range seq most-negative-fixnum 0)
    (sleepycat::db-sequence-initial-value seq (+ most-negative-fixnum 99))
    (sleepycat::db-sequence-open seq "testseq2"
		      :auto-commit t :create t :thread t)
    (loop for i = (sleepycat::db-sequence-get-fixnum seq 1 :auto-commit t :txn-nosync t)
	  for j from (+ most-negative-fixnum 99) downto most-negative-fixnum
	  while (< i 0)
	  do
	  (assert (= i j))
	  finally (sleepycat::db-sequence-remove seq :auto-commit t))))

(deftest test-seq2
    (finishes (test-sequence2))
  t)

(defun cleanup-sleepycat ()
  (sleepycat::db-close db)
  (sleepycat::db-env-dbremove env "testsleepycat" :database "bar")
  (sleepycat::db-env-close env)
  (setq env (sleepycat::db-env-create))
  (sleepycat::db-env-remove env "test"))

(deftest cleansup-sleepycat
    (finishes (cleanup-sleepycat))
  t)

;;(unuse-package "SLEEPYCAT")
;;(use-package "ELE")

#|
(defun txn-alot (iters)
  (loop for i from 1 to iters
	do
	(with-transaction (:environment env)
	  (db-put db "mykey" "mydatum"))))	     

(defun get-alot-b (keys)
  (loop for key in keys
	do
	(db-get-buffered db key)))

(defun foreign-test (ln iters)
  (with-transaction (:environment env)
    (loop for i fixnum from 1 to iters
	  with write-buf of-type array-or-pointer-char = (uffi:allocate-foreign-object :char ln)
	  with str string = (make-string ln :initial-element #\c)
	  with key-buf of-type array-or-pointer-char = (uffi:allocate-foreign-object :char 2)
	  do
	  (copy-str-to-buf "fs" key-buf)
	  (copy-str-to-buf str write-buf)
	  (db-put-buffered db key-buf 2 write-buf ln)
	  finally 
	  (progn 
	    (uffi:free-foreign-object write-buf)
	    (uffi:free-foreign-object key-buf)))))

(defun cstring-test (ln iters)
  (with-transaction (:environment env)
    (loop for i fixnum from 1 to iters
	  with str string = (make-string ln :initial-element #\c)
	  do
	  (db-put db "fs" str))))
|#

